<?php
/**
 * @package    VP Advanced User
 * @author     Abhishek Das <info@virtueplanet.com>
 * @copyright  Copyright (C) 2012-2019 VirtuePlanet Services LLP. All rights reserved.
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 * @link       https://www.virtueplanet.com
 */

defined('_JEXEC') or die;

/**
* Methods supporting a list of records.
*/
class VPAdvancedUserModelEmailtemplates extends JModelList 
{
/**
	* Constructor.
	*
	* @param   array  $config  An optional associative array of configuration settings.
	*
	* @see        JController
	* @since      1.0
	*/
	public function __construct($config = array()) 
	{
		if (empty($config['filter_fields'])) 
		{
			$config['filter_fields'] = array(
			          'id', 'a.id',
			          'ordering', 'a.ordering',
			          'state', 'a.state',
			          'mode', 'a.mode',
			          'created_by', 'a.created_by',
			          'name', 'a.name',
			          'subject', 'a.subject',
			          'template', 'a.template',
			          'is_default', 'a.is_default',
			          'purpose', 'a.purpose',
		          );
		}

		parent::__construct($config);
	}

	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @param   string  $ordering   Elements order
	 * @param   string  $direction  Order direction
	 *
	 * @return void
	 *
	 * @throws Exception
	 */
	protected function populateState($ordering = null, $direction = null) 
	{
		// Initialise variables.
		$app = JFactory::getApplication('administrator');

		// Load the filter state.
		$search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
		$this->setState('filter.search', $search);

		$published = $app->getUserStateFromRequest($this->context . '.filter.state', 'filter_published', '', 'string');
		$this->setState('filter.state', $published);

		// Load the filter addresstype.
		$this->setState('filter.purpose', $app->getUserStateFromRequest($this->context.'.filter.purpose', 'filter_purpose', '', 'string'));

		// Load the parameters.
		$params = JComponentHelper::getParams('com_vpadvanceduser');
		$this->setState('params', $params);

		// List state information.
		parent::populateState('a.id', 'asc');
	}

	/**
	 * Method to get a store id based on model configuration state.
	 *
	 * This is necessary because the model is used by the component and
	 * different modules that might need different sets of data or different
	 * ordering requirements.
	 *
	 * @param   string  $id  A prefix for the store id.
	 *
	 * @return   string A store id.
	 *
	 * @since    1.6
	 */
	protected function getStoreId($id = '') 
	{
		// Compile the store id.
		$id.= ':' . $this->getState('filter.search');
		$id.= ':' . $this->getState('filter.state');

		return parent::getStoreId($id);
	}

	/**
	 * Build an SQL query to load the list data.
	 *
	 * @return   JDatabaseQuery
	 *
	 * @since    1.6
	 */
	protected function getListQuery() 
	{
		// Create a new query object.
		$db    = $this->getDbo();
		$query = $db->getQuery(true);

		// Select the required fields from the table.
		$query->select(
					$this->getState(
						'list.select', 'a.`id`, a.`ordering`, a.`state`, a.`mode`, a.`checked_out`, a.`checked_out_time`, a.`name`, a.`subject`, a.`is_default`, a.`purpose`'
					)
				);

		$query->from('`#__vpadvanceduser_emailtemplates` AS a');

		// Join over the users for the checked out user.
		$query->select('uc.`name` AS editor')
		      ->join('LEFT', '`#__users` AS uc ON uc.`id` = a.`checked_out`');

		// Join over the user field 'created_by'
		$query->select('cb.`name` AS created_by')
		      ->join('LEFT', '`#__users` AS cb ON cb.`id` = a.`created_by`');

		// Filter by published state
		$published = $this->getState('filter.state');
		
		if (is_numeric($published)) 
		{
			$query->where('a.`state` = '.(int) $published);
		} 
		else if ($published === '') 
		{
			$query->where('(a.`state` IN (0, 1))');
		}

		// Filter by search in title
		$search = $this->getState('filter.search');
		
		if ($this->getState('filter.search') !== '')
		{
			// Escape the search token.
			$token = $db->quote('%' . $db->escape($this->getState('filter.search')) . '%');

			// Add the clauses to the query.
			$query->where('a.`name` LIKE ' . $token .' OR a.`subject` Like ' . $token . ' OR a.`purpose` LIKE' . $token);
		}

		// Filter By purpose of the email
		$filter_purpose = $this->state->get('filter.purpose');
		
		if ($filter_purpose != '' && $filter_purpose != '*') 
		{
			$query->where('a.`purpose` = '.  $db->quote($db->escape($filter_purpose)));
		}

		// Add the list ordering clause.
		$orderCol  = $this->state->get('list.ordering');
		$orderDirn = $this->state->get('list.direction');

		if ($orderCol && $orderDirn) 
		{
			$query->order($db->escape($orderCol . ' ' . $orderDirn));
		}

		return $query;
	}

	public function getItems() 
	{
		return parent::getItems();
	}

	public function getPurposes()
	{
		return array(
			'user_registration'  => JText::_('COM_VPADVANCEDUSER_EMAIL_USER_REGISTRATION'),
			'user_activation'    => JText::_('COM_VPADVANCEDUSER_EMAIL_USER_ACTIVATION'),
			'admin_activation'   => JText::_('COM_VPADVANCEDUSER_EMAIL_ADMINISTRATOR_ACTIVATION'),
			'password_reset'     => JText::_('COM_VPADVANCEDUSER_EMAIL_PASSWORD_RESET'),
			'admin_notification' => JText::_('COM_VPADVANCEDUSER_EMAIL_ADMINISTRATOR_NOTIFICATION')
		);
	}
}
